/* Copyright 2001, 2003 - Andrea Marchesini - bakunin
 *                        <bakunin@autistici.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include <sdf.h>

/* Write the buffer get by curl function. */
int
sdf_fwrite (void *buffer, size_t size, size_t nmemb, void *stream)
{
  struct sdf_t *sdf = (struct sdf_t *) stream;

  /* If fd is close, open it */
  if (!sdf->fd)
    {

      D ("Opening filedescriptor.\n");

      if (!(sdf->fd = fopen (sdf->file, "wb")))
	return -1;
    }

  return fwrite (buffer, size, nmemb, sdf->fd);

}

/* Check the SDF directory and a correct file name for the remote file in 
 * locale */
char *
sdf_mk_name (void)
{
  char *r;
  struct stat st;
  struct passwd *pwd;
  int d = 0;

  if (!(pwd = getpwuid (getuid ())))
    return NULL;

  if (!(r = (char *) malloc ((10 + strlen (pwd->pw_dir)) * sizeof (char))))
    return NULL;

  /* Directory SDF check */
  sprintf (r, "%s/.sdf", pwd->pw_dir);
  if (lstat (r, &st))
    {

      D ("Creating %s/.sdf directory.\n", pwd->pw_dir);
      if (mkdir (r, S_IRWXU))
	return NULL;
    }

  while (d < 999)
    {
      sprintf (r, "%s/.sdf/%d", pwd->pw_dir, d);

      D ("File check: %s\n", r);

      if (lstat (r, &st))
	{
	  D ("File name OK: %s\n", r);

	  return r;
	}

      d++;
    }

  free (r);

  return NULL;

}
