/* Copyright 2001, 2003 - Andrea Marchesini - bakunin
 *                        <bakunin@autistici.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#ifndef _DEF_H
#define _DEF_H

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>

/* Curl include */
#include <curl/curl.h>
#include <curl/types.h>
#include <curl/easy.h>

/* dynamic library */
#include <dlfcn.h>

#include <sys/stat.h>
#include <sys/types.h>

#include <unistd.h>

/* passwd manager */
#include <pwd.h>

/* lib confuse */
#include <confuse.h>

/* Macro for debug information */
#if DEBUG
#define D(x...) fprintf(stderr,x)
#else
#define D(x...)
#endif

/* Struct base for Simple Distribuited Filesystem */
struct sdf_t
{
  char *file;
  FILE *fd;
};

/* Struct base for config file .sdfrc */
struct sdf_conf_t
{
  char *proxy;
  int port;
  int type;
};

int sdf_fwrite (void *, size_t, size_t, void *);
char *sdf_mk_name (void);
struct sdf_conf_t *sdf_conf_init (void);
void sdf_conf_cleanup (struct sdf_conf_t *);

#endif

/* EOF */
